import { defineComponent as P, shallowRef as D, computed as b, onMounted as _, createVNode as m, reactive as X, onBeforeUnmount as J, watch as H, mergeProps as B, ref as K, isVNode as Q } from "vue";
function C() {
  return typeof window < "u" && "IntersectionObserver" in window && "isIntersecting" in window.IntersectionObserverEntry.prototype;
}
const x = {}, ee = (e) => {
  e.forEach((t) => {
    t.isIntersecting && t.target.onVisible(t);
  });
}, te = (e) => (x[e] = x[e] || new IntersectionObserver(ee, {
  rootMargin: e + "px"
}), x[e]), M = () => typeof window > "u" ? 0 : window.scrollX || window.pageXOffset, $ = () => typeof window > "u" ? 0 : window.scrollY || window.pageYOffset, k = () => ({
  onAfterLoad: {
    type: Function,
    default: () => {
    }
  },
  onBeforeLoad: {
    type: Function,
    default: () => {
    }
  },
  onVisible: {
    type: Function,
    default: () => {
    }
  },
  scrollPosition: {
    type: Object,
    default: null
  },
  visibleByDefault: {
    type: Boolean,
    default: !1
  },
  height: {
    type: Number,
    default: 0
  },
  width: {
    type: Number,
    default: 0
  },
  useIntersectionObserver: {
    type: Boolean,
    default: !0
  },
  threshold: {
    type: Number,
    default: 300
  },
  style: {
    type: Object,
    default: () => {
    }
  },
  class: {
    type: String,
    default: ""
  },
  delayMethod: {
    type: String,
    default: "throttle"
  },
  delayTime: {
    type: Number,
    default: 300
  },
  placeholder: {
    type: Object,
    default: () => {
    }
  }
}), ne = () => ({
  ...k(),
  onImageError: {
    type: Function,
    default: () => {
    }
  },
  effect: {
    type: String,
    default: ""
  },
  placeholderSrc: {
    type: String,
    default: ""
  },
  wrapperClassName: {
    type: String,
    default: ""
  },
  wrapperProps: {
    type: Object,
    default: () => ({})
  },
  loadedClassName: {
    type: String,
    default: ""
  }
}), re = () => ({
  style: {
    type: Object,
    default: () => {
    }
  },
  class: {
    type: String,
    default: ""
  },
  scrollPosition: {
    type: Object,
    default: null
  },
  useIntersectionObserver: {
    type: Boolean,
    default: !0
  },
  threshold: {
    type: Number,
    default: 300
  },
  onVisible: {
    type: Function,
    default: () => {
    }
  },
  height: {
    type: Number,
    default: 100
  },
  width: {
    type: Number,
    default: 100
  },
  placeholder: {
    type: Object,
    default: () => {
    }
  }
}), oe = () => ({
  scrollPosition: {
    type: Object,
    default: null
  },
  useIntersectionObserver: {
    type: Boolean,
    default: !0
  },
  threshold: {
    type: Number,
    default: 300
  },
  onVisible: {
    type: Function,
    default: () => {
    }
  },
  height: {
    type: Number,
    default: 0
  },
  width: {
    type: Number,
    default: 0
  },
  placeholder: {
    type: Object,
    default: () => {
    }
  }
}), U = /* @__PURE__ */ P({
  name: "PlaceholderWithoutTracking",
  inheritAttrs: !1,
  props: re(),
  setup(e, {
    emit: t
  }) {
    const n = D(), r = b(() => !e.scrollPosition && e.useIntersectionObserver && C()), l = b(() => r.value ? te(e.threshold) : null);
    function u(a = e.scrollPosition) {
      const d = n.value.getBoundingClientRect(), h = n.value.style, g = {
        left: parseInt(h.getPropertyValue("margin-left"), 10) || 0,
        top: parseInt(h.getPropertyValue("margin-top"), 10) || 0
      };
      return {
        bottom: a.y + d.bottom + g.top,
        left: a.x + d.left + g.left,
        right: a.x + d.right + g.left,
        top: a.y + d.top + g.top
      };
    }
    function i() {
      if (typeof window > "u" || n.value)
        return !1;
      const a = u(e.scrollPosition), d = {
        bottom: e.scrollPosition.y + window.innerHeight,
        left: e.scrollPosition.x,
        right: e.scrollPosition.x + window.innerWidth,
        top: e.scrollPosition.y
      };
      return d.top - e.threshold <= a.bottom && d.bottom + e.threshold >= a.top && d.left - e.threshold <= a.right && d.right + e.threshold >= a.left;
    }
    function o() {
      i() && t("visible");
    }
    _(() => {
      l.value && n.value && (n.value.onVisible = e.onVisible, l.value.observe(n.value)), r.value || o == null || o();
    });
    const f = b(() => ({
      display: "inline-block",
      height: `${e.height}px`,
      width: `${e.width}px`,
      ...e.style
    }));
    return () => m("span", {
      ref: n,
      style: f.value
    }, [e.placeholder]);
  }
});
var ie = typeof global == "object" && global && global.Object === Object && global;
const le = ie;
var ae = typeof self == "object" && self && self.Object === Object && self, ce = le || ae || Function("return this")();
const Y = ce;
var se = Y.Symbol;
const L = se;
var G = Object.prototype, ue = G.hasOwnProperty, de = G.toString, O = L ? L.toStringTag : void 0;
function fe(e) {
  var t = ue.call(e, O), n = e[O];
  try {
    e[O] = void 0;
    var r = !0;
  } catch {
  }
  var l = de.call(e);
  return r && (t ? e[O] = n : delete e[O]), l;
}
var ge = Object.prototype, he = ge.toString;
function ye(e) {
  return he.call(e);
}
var be = "[object Null]", me = "[object Undefined]", A = L ? L.toStringTag : void 0;
function ve(e) {
  return e == null ? e === void 0 ? me : be : A && A in Object(e) ? fe(e) : ye(e);
}
function we(e) {
  return e != null && typeof e == "object";
}
var Oe = "[object Symbol]";
function Pe(e) {
  return typeof e == "symbol" || we(e) && ve(e) == Oe;
}
var Ie = /\s/;
function Le(e) {
  for (var t = e.length; t-- && Ie.test(e.charAt(t)); )
    ;
  return t;
}
var Se = /^\s+/;
function Te(e) {
  return e && e.slice(0, Le(e) + 1).replace(Se, "");
}
function S(e) {
  var t = typeof e;
  return e != null && (t == "object" || t == "function");
}
var z = 0 / 0, pe = /^[-+]0x[0-9a-f]+$/i, Ee = /^0b[01]+$/i, je = /^0o[0-7]+$/i, xe = parseInt;
function R(e) {
  if (typeof e == "number")
    return e;
  if (Pe(e))
    return z;
  if (S(e)) {
    var t = typeof e.valueOf == "function" ? e.valueOf() : e;
    e = S(t) ? t + "" : t;
  }
  if (typeof e != "string")
    return e === 0 ? e : +e;
  e = Te(e);
  var n = Ee.test(e);
  return n || je.test(e) ? xe(e.slice(2), n ? 2 : 8) : pe.test(e) ? z : +e;
}
var Ne = function() {
  return Y.Date.now();
};
const N = Ne;
var Be = "Expected a function", Ce = Math.max, ke = Math.min;
function Z(e, t, n) {
  var r, l, u, i, o, f, a = 0, d = !1, h = !1, g = !0;
  if (typeof e != "function")
    throw new TypeError(Be);
  t = R(t) || 0, S(n) && (d = !!n.leading, h = "maxWait" in n, u = h ? Ce(R(n.maxWait) || 0, t) : u, g = "trailing" in n ? !!n.trailing : g);
  function c(s) {
    var y = r, v = l;
    return r = l = void 0, a = s, i = e.apply(v, y), i;
  }
  function T(s) {
    return a = s, o = setTimeout(w, t), d ? c(s) : i;
  }
  function V(s) {
    var y = s - f, v = s - a, j = t - y;
    return h ? ke(j, u - v) : j;
  }
  function p(s) {
    var y = s - f, v = s - a;
    return f === void 0 || y >= t || y < 0 || h && v >= u;
  }
  function w() {
    var s = N();
    if (p(s))
      return E(s);
    o = setTimeout(w, V(s));
  }
  function E(s) {
    return o = void 0, g && r ? c(s) : (r = l = void 0, i);
  }
  function W() {
    o !== void 0 && clearTimeout(o), a = 0, r = f = l = o = void 0;
  }
  function F() {
    return o === void 0 ? i : E(N());
  }
  function I() {
    var s = N(), y = p(s);
    if (r = arguments, l = this, f = s, y) {
      if (o === void 0)
        return T(f);
      if (h)
        return clearTimeout(o), o = setTimeout(w, t), c(f);
    }
    return o === void 0 && (o = setTimeout(w, t)), i;
  }
  return I.cancel = W, I.flush = F, I;
}
var Ve = "Expected a function";
function We(e, t, n) {
  var r = !0, l = !0;
  if (typeof e != "function")
    throw new TypeError(Ve);
  return S(n) && (r = "leading" in n ? !!n.leading : r, l = "trailing" in n ? !!n.trailing : l), Z(e, t, {
    leading: r,
    maxWait: t,
    trailing: l
  });
}
const Fe = (e) => {
  const t = getComputedStyle(e, null);
  return t.getPropertyValue("overflow") + t.getPropertyValue("overflow-y") + t.getPropertyValue("overflow-x");
}, Me = (e) => {
  if (!(e instanceof HTMLElement))
    return window;
  let t = e;
  for (; t && t instanceof HTMLElement; ) {
    if (/(scroll|auto)/.test(Fe(t)))
      return t;
    t = t.parentNode;
  }
  return window;
}, $e = (e) => /* @__PURE__ */ P({
  name: "ScrollAwareComponent",
  props: k(),
  setup(t, {
    attrs: n
  }) {
    const r = b(() => t.useIntersectionObserver && C()), l = D(null), u = X({
      x: M(),
      y: $()
    });
    if (!r.value)
      return null;
    function i() {
      r.value || (u.x = M(), u.y = $());
    }
    const o = b(() => Me(l.value));
    function f() {
      typeof window > "u" || r || (o.value.addEventListener("scroll", i), window.addEventListener("resize", i), o.value !== document.body && window.addEventListener("scroll", i));
    }
    function a() {
      typeof window > "u" || r || (o.value.removeEventListener("scroll", i), window.removeEventListener("resize", i), o.value !== document.body && window.removeEventListener("scroll", i));
    }
    _(() => {
      f();
    }), J(() => {
      a();
    }), H(o, (h, g) => {
      g && a(), f();
    });
    const d = t.delayMethod === "debounce" ? Z(i, t.delayTime) : We(i, t.delayTime);
    return () => m(e, B(t, n, {
      scrollPosition: u,
      ref: l,
      onChangeScroll: d
    }), null);
  }
}), Ae = /* @__PURE__ */ P({
  compatConfig: {
    MODE: 3
  },
  name: "PlaceholderWithTracking",
  inheritAttrs: !1,
  props: oe(),
  setup(e) {
    return () => m(U, e, null);
  }
}), ze = $e(Ae), Re = /* @__PURE__ */ P({
  compatConfig: {
    MODE: 3
  },
  name: "LazyLoadComponent",
  inheritAttrs: !1,
  props: k(),
  setup(e, {
    slots: t,
    emit: n
  }) {
    const r = X({
      visible: e.visibleByDefault ?? !1,
      loaded: !1,
      error: !1
    }), l = b(() => !!(e.scrollPosition && Number.isFinite(e.scrollPosition.x) && e.scrollPosition.x >= 0 && Number.isFinite(e.scrollPosition.y) && e.scrollPosition.y >= 0));
    H(r, (i, o) => {
      i.visible !== (o == null ? void 0 : o.visible) && n("afterLoad");
    }, {
      immediate: !0
    });
    const u = (i) => {
      r.visible = !0, n("afterLoad"), n("visible", i);
    };
    return e.visibleByDefault && (n("beforeLoad"), n("afterLoad")), () => {
      var i;
      return r.visible ? (i = t.default) == null ? void 0 : i.call(t) : l.value || e.useIntersectionObserver && C() ? m(U, {
        height: e.height,
        onVisible: u,
        placeholder: e.placeholder,
        scrollPosition: e.scrollPosition,
        threshold: e.threshold,
        useIntersectionObserver: e.useIntersectionObserver,
        width: e.width,
        style: e.style,
        class: e.class
      }, null) : m(ze, {
        height: e.height,
        onVisible: u,
        placeholder: e.placeholder,
        scrollPosition: e.scrollPosition,
        threshold: e.threshold,
        useIntersectionObserver: e.useIntersectionObserver,
        width: e.width,
        style: e.style,
        class: e.class
      }, null);
    };
  }
});
function De(e) {
  return typeof e == "function" || Object.prototype.toString.call(e) === "[object Object]" && !Q(e);
}
const Ge = /* @__PURE__ */ P({
  name: "LazyLoadImage",
  inheritAttrs: !1,
  compatConfig: {
    MODE: 3
  },
  props: ne(),
  setup(e, {
    emit: t,
    attrs: n
  }) {
    const r = K(!1);
    function l() {
      if (!r.value)
        return (c) => {
          t("afterLoad", c), r.value = !0;
        };
    }
    const u = (c) => {
      t("imageError", c);
    }, i = (c) => {
      t("visible", c);
    }, o = () => {
      t("beforeLoad");
    };
    function f() {
      const c = b(() => {
        const {
          onAfterLoad: T,
          onBeforeLoad: V,
          onVisible: p,
          delayMethod: w,
          delayTime: E,
          effect: W,
          placeholder: F,
          placeholderSrc: I,
          scrollPosition: s,
          threshold: y,
          useIntersectionObserver: v,
          visibleByDefault: j,
          wrapperClassName: _e,
          wrapperProps: Xe,
          loadedClassName: He,
          onImageError: Ue,
          ...q
        } = e;
        return q;
      });
      return m("img", B({
        onLoad: l(),
        onError: u
      }, c.value, n), null);
    }
    function a() {
      let c;
      return m(Re, {
        onVisible: i,
        onBeforeLoad: o,
        class: e.class,
        delayMethod: e.delayMethod,
        delayTime: e.delayTime,
        height: e.height,
        placeholder: e.placeholder,
        scrollPosition: e.scrollPosition,
        style: e.style,
        threshold: e.threshold,
        useIntersectionObserver: e.useIntersectionObserver,
        visibleByDefault: e.visibleByDefault,
        width: e.width
      }, De(c = f()) ? c : {
        default: () => [c]
      });
    }
    const d = b(() => r.value ? " lazy-load-image-loaded" : ""), h = b(() => r.value || !e.placeholderSrc ? {} : {
      backgroundImage: `url(${e.placeholderSrc})`,
      backgroundSize: "100% 100%"
    });
    function g(c) {
      return m("span", B({
        class: e.wrapperClassName + " lazy-load-image-background " + e.effect + d.value,
        style: {
          ...h.value,
          color: "transparent",
          display: "inline-block",
          height: e.height + "px",
          width: e.width + "px"
        }
      }, e.wrapperProps), [c]);
    }
    return () => {
      const c = a();
      return !((e.effect || e.placeholderSrc) && !e.visibleByDefault) && !e.wrapperClassName && !e.wrapperProps ? c : g(c);
    };
  }
});
export {
  Re as LazyLoadComponent,
  Ge as LazyLoadImage,
  $e as trackWindowScroll
};
